local THIS_ADDON, data = ...
GarrisonHelper_data = data
GarrisonHelper_Local = GarrisonHelper_Local or {}

-- Frame and Events
local GarrisonHelper_Events = CreateFrame("Frame");
local events = {};
-- IDs
local kristenStoneforge = 77377;
local grunlek = 79815;
local ironHordeScraps = 113681;
local scrapMeltdownA = 38175;
local scrapMeltdownH = 38188;

-- is NPC with ID id targeted
local function isNPC(id)
	return UnitExists("target") and tonumber( select( 6, strsplit( "-", UnitGUID("target") ) ), 10 ) == id; 
end
local function isNeededNPC()
	return isNPC(kristenStoneforge) or isNPC(grunlek); 
end
local function isNeededQuest()
	return GetQuestID()==scrapMeltdownA or GetQuestID()==scrapMeltdownH; 
end


function events.GOSSIP_SHOW()
	if isNeededNPC() and GetItemCount(ironHordeScraps)>=25 then 
		if GetNumGossipAvailableQuests()==1 then
			SelectGossipAvailableQuest(1);
		end
		if GetNumGossipActiveQuests()==1 then
			SelectGossipActiveQuest(1);
		end
	end
end

function events.QUEST_DETAIL()
	if isNeededQuest() and GetItemCount(ironHordeScraps)>=25 then 
		AcceptQuest();
	end
end

function events.QUEST_COMPLETE()
	if isNeededQuest() and GetItemCount(ironHordeScraps)>=25 then 
		local o = GarrisonHelper_Local["QuestReward"] or 4;
		if o==3 then
			if math.random()>0.5 then o=1 else o=2 end
			-- print("random: " .. o);
		elseif o==4 then
			local weaponCount = 3*GetItemCount(114128)+6*GetItemCount(114131)+9*GetItemCount(114129);
			local armorCount = 3*GetItemCount(114745)+6*GetItemCount(114808)+9*GetItemCount(114822);
			-- print("smart: " .. "w=" .. weaponCount .. " a=" .. armorCount);
			if weaponCount > armorCount then o=1 else o=2 end
		end
		-- print("option " .. o);
		if GetNumQuestChoices() == 2 then GetQuestReward(o); end
	end
end

function events.ADDON_LOADED()
	GarrisonHelper_ConfigInit();
end

function events.QUEST_PROGRESS()
	if isNeededQuest() and GetItemCount(ironHordeScraps)>=25 then
		if IsQuestCompletable() then CompleteQuest() end 
	end
end


-- register event listener
GarrisonHelper_Events:SetScript("OnEvent", function(self, event, ...) events[event](); end);
for event, func in pairs(events) do GarrisonHelper_Events:RegisterEvent(event); end