local ADDON, data = ...

local rewardOption = 4;
local locHeadlineMsg = "Choose Dwarven Bunker/War Mill daily quest reward"
local rewards = {
    "Armor Token",
    "Weapon Token",
    "Random Token",
	"Smart Choice",
}
local expl = {
    "",
    "",
    "Chooses a random token as reward.",
	"Chooses the token which you have less.",
}

-- [[ Main Panel ]] --
	local mainPanel = CreateFrame("Frame", "GarrisonHelperConfig", InterfaceOptionsFramePanelContainer)
	mainPanel:Hide()
	mainPanel.name = "GarrisonHelper"
	local title = mainPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText("GarrisonHelper")
	local desc = mainPanel:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
	desc:SetPoint("TOPLEFT", 16, -48)
	desc:SetText(locHeadlineMsg)
	InterfaceOptions_AddCategory(mainPanel)

-- [[ DropDown Rewards ]] --

	-- Create dropdownmenu
	if not GarrisonHelper_OptionsFormatMenu then
		CreateFrame("Button", "GarrisonHelper_OptionsFormatMenu", mainPanel, "UIDropDownMenuTemplate")
	end

	-- Set dropdownmenu location
	GarrisonHelper_OptionsFormatMenu:ClearAllPoints()
	GarrisonHelper_OptionsFormatMenu:SetPoint("TOPLEFT", 16, -64)
	GarrisonHelper_OptionsFormatMenu:Show()

	-- Set explanation location
	local EXPLANATION = mainPanel:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
	EXPLANATION:SetPoint("TOPLEFT", 200, -72)
	EXPLANATION:SetText(expl[GarrisonHelper_Local["QuestReward"]])
	EXPLANATION:SetTextColor(1, 1, 1, 1)

	-- OnClick function for dropdownmenu
	local function GarrisonHelper_OptionsFormatMenu_OnClick(self, arg1, arg2, checked)
		rewardOption = arg1
		GarrisonHelper_Local["QuestReward"] = rewardOption
		UIDropDownMenu_SetText(GarrisonHelper_OptionsFormatMenu, rewards[rewardOption])
		EXPLANATION:SetText(expl[GarrisonHelper_Local["QuestReward"]])
		GarrisonHelper_Local.timestamp = time ()
	end

	-- Initialization function for dropdownmenu
	local function GarrisonHelper_OptionsFormatMenu_Initialize(self, level)
		local info = UIDropDownMenu_CreateInfo()
		info = UIDropDownMenu_CreateInfo()
		info.func = GarrisonHelper_OptionsFormatMenu_OnClick
		info.arg1, info.text = 1, rewards[1]
		UIDropDownMenu_AddButton(info)
		info.arg1, info.text = 2, rewards[2]
		UIDropDownMenu_AddButton(info)
		info.arg1, info.text = 3, rewards[3]
		UIDropDownMenu_AddButton(info)
		info.arg1, info.text = 4, rewards[4]
		UIDropDownMenu_AddButton(info)
	end

	-- Final setup for dropdownmenu
	UIDropDownMenu_Initialize(GarrisonHelper_OptionsFormatMenu, GarrisonHelper_OptionsFormatMenu_Initialize)
	UIDropDownMenu_SetWidth(GarrisonHelper_OptionsFormatMenu, 148);
	UIDropDownMenu_SetButtonWidth(GarrisonHelper_OptionsFormatMenu, 124)
	UIDropDownMenu_SetText(GarrisonHelper_OptionsFormatMenu, rewards[tonumber(GarrisonHelper_Local["QuestReward"])])
	UIDropDownMenu_JustifyText(GarrisonHelper_OptionsFormatMenu, "LEFT")

	-- Apply Globally
    local btnApplyGlobally = CreateFrame ("Button", '', mainPanel, "UIPanelButtonTemplate")
    btnApplyGlobally:SetSize (300,25)
    btnApplyGlobally:SetPoint ("BOTTOMLEFT", mainPanel, "BOTTOMLEFT", 16, 8)
    btnApplyGlobally:SetText ("Apply choice of rewards to all characters!")
    btnApplyGlobally:SetScript ("OnClick", function () ApplyGlobally() end)
	
-- Init and set variables --
function GarrisonHelper_ConfigInit()
	GarrisonHelper_Global = GarrisonHelper_Global or {}
	if GarrisonHelper_Global.timestamp and (GarrisonHelper_Global.timestamp > (GarrisonHelper_Local.timestamp or 0)) then
		for k,v in pairs(GarrisonHelper_Global) do
			GarrisonHelper_Local[k] = v
		end
	else
		GarrisonHelper_Local = GarrisonHelper_Local or {}
		if(GarrisonHelper_Local["QuestReward"]==nil) then
			rewardOption = 4; -- defautlt:4  (Smart Choice)
			GarrisonHelper_Local["QuestReward"] = rewardOption;
		else
			rewardOption = tonumber(GarrisonHelper_Local["QuestReward"])
		end
		
	end
    UIDropDownMenu_SetText(GarrisonHelper_OptionsFormatMenu, rewards[rewardOption])
    EXPLANATION:SetText(expl[GarrisonHelper_Local["QuestReward"]])
	
end

function ApplyGlobally()
    GarrisonHelper_Global = {}
    for k,v in pairs(GarrisonHelper_Local) do
        GarrisonHelper_Global[k] = v
    end
    GarrisonHelper_Global.timestamp = time ()
end

SlashCmdList["GARRISONHELPER"] = function(msg)
    InterfaceOptionsFrame:Show()
    InterfaceOptionsFrameTab2:Click()
    local i = 1
    local currAddon = "InterfaceOptionsFrameAddOnsButton" .. i
    while _G[currAddon] do
        if (_G[currAddon]:GetText() == "GarrisonHelper") then _G[currAddon]:Click() break end
        i = i + 1
        currAddon = "InterfaceOptionsFrameAddOnsButton" .. i
    end
end
SLASH_GARRISONHELPER1 = "/garrisonhelper"
SLASH_GARRISONHELPER2 = "/gh"